diff -Nru teeworlds-0.5.1-src/src/engine/e_network.c sendtoerror/teeworlds-0.5.1-src/src/engine/e_network.c
--- teeworlds-0.5.1-src/src/engine/e_network.c	2009-01-25 13:50:32.000000000 +0100
+++ sendtoerror/teeworlds-0.5.1-src/src/engine/e_network.c	2009-08-20 22:05:59.000000000 +0200
@@ -141,7 +141,7 @@
 	return huffman_decompress(&huffmanstate, data, data_size, output, output_size);
 }
 
-void send_packet(NETSOCKET socket, NETADDR *addr, NETPACKETCONSTRUCT *packet)
+int send_packet(NETSOCKET socket, NETADDR *addr, NETPACKETCONSTRUCT *packet)
 {
 	unsigned char buffer[NET_MAX_PACKETSIZE];
 	int compressed_size = -1;
@@ -178,11 +178,12 @@
 	/* set header and send the packet if all things are good */
 	if(final_size >= 0)
 	{
+		int result = 0;
 		final_size += NET_PACKETHEADERSIZE;
 		buffer[0] = ((packet->flags<<4)&0xf0)|((packet->ack>>8)&0xf);
 		buffer[1] = packet->ack&0xff;
 		buffer[2] = packet->num_chunks;
-		net_udp_send(socket, addr, buffer, final_size);
+		result = net_udp_send(socket, addr, buffer, final_size);
 
 		/* log raw socket data */
 		if(datalog_sent)
@@ -193,7 +194,9 @@
 			io_write(datalog_sent, buffer, final_size);
 			io_flush(datalog_sent);
 		}
+		return result < 0 ? result : 0;
 	}
+	return 0;
 }
 
 /* TODO: rename this function */
diff -Nru teeworlds-0.5.1-src/src/engine/e_network_conn.c sendtoerror/teeworlds-0.5.1-src/src/engine/e_network_conn.c
--- teeworlds-0.5.1-src/src/engine/e_network_conn.c	2009-01-25 13:50:32.000000000 +0100
+++ sendtoerror/teeworlds-0.5.1-src/src/engine/e_network_conn.c	2009-08-20 22:07:53.000000000 +0200
@@ -75,7 +75,11 @@
 
 	/* send of the packets */	
 	conn->construct.ack = conn->ack;
-	send_packet(conn->socket, &conn->peeraddr, &conn->construct);
+	if(send_packet(conn->socket, &conn->peeraddr, &conn->construct))
+	{
+		conn->state = NET_CONNSTATE_ERROR;
+		conn_set_error(conn, "send error");
+	}
 	
 	/* update send times */
 	conn->last_send_time = time_get();
diff -Nru teeworlds-0.5.1-src/src/engine/e_network_internal.h sendtoerror/teeworlds-0.5.1-src/src/engine/e_network_internal.h
--- teeworlds-0.5.1-src/src/engine/e_network_internal.h	2009-01-25 13:50:32.000000000 +0100
+++ sendtoerror/teeworlds-0.5.1-src/src/engine/e_network_internal.h	2009-08-20 22:04:10.000000000 +0200
@@ -150,7 +150,7 @@
 int seq_in_backroom(int seq, int ack);
 void send_controlmsg(NETSOCKET socket, NETADDR *addr, int ack, int controlmsg, const void *extra, int extra_size);
 void send_packet_connless(NETSOCKET socket, NETADDR *addr, const void *data, int data_size);
-void send_packet(NETSOCKET socket, NETADDR *addr, NETPACKETCONSTRUCT *packet);
+int send_packet(NETSOCKET socket, NETADDR *addr, NETPACKETCONSTRUCT *packet);
 int unpack_packet(unsigned char *buffer, int size, NETPACKETCONSTRUCT *packet);
 unsigned char *pack_chunk_header(unsigned char *data, int flags, int size, int sequence);
 unsigned char *unpack_chunk_header(unsigned char *data, NETCHUNKHEADER *header);
